#-----------------------------------------------------------
#defining a default distribution if dist not present
%{!?dist: %define dist .el6.4}

%define	sysinit	sysvinit
%if 0%{?fedora} > 17
%define	sysinit	systemd
%endif
#---------------------------------------------------------------
#---------------------------------------------------------------
%global _hardened_build 1
#---------------------------------------------------------------
Name:		clement
Summary:	clement is an application to filter and manage E-mail traffic
Group:		System Environment/Daemons
Version:	2.6 
Release:	4.8.1%{?dist}%{?orig}
License:	GPLv2
Source:		%{name}-%{version}.tgz
URL:		http://www.clement.safe.ca/index.html
Vendor:		SAFE Inc.
Requires:	/usr/sbin/crond
Requires:	logrotate
Requires:	httpd, mod_ssl
Requires:	/bin/sh, /bin/cut, /usr/bin/cpp, /usr/bin/du, /bin/sed
Requires:	openssl, rrdtool, rsync
Requires:	dovecot >= 2.0, dovecot-pgsql, dovecot-mysql, dovecot-pigeonhole
Requires:	php >= 5.2, php-imap,php-ldap,php-mysql,php-pgsql
Requires:	openldap-clients
Requires:	clamav-server, /usr/bin/spamd
Requires:	which, bc
Requires:	postgresql-libs,postgresql-contrib,mysql
Requires:	yagac-libs >= 0.99-4
Requires:	expect
Requires(pre):	/usr/sbin/useradd,/usr/sbin/userdel,/usr/sbin/usermod
Requires(post):	/usr/bin/dig
BuildRequires:	/usr/bin/byacc, /usr/bin/cpp
BuildRequires:	zlib-devel,bzip2-devel,gmp-devel,pam-devel,openssl-devel
BuildRequires:	postgresql-devel,mysql-devel
BuildRequires:	openldap-devel
BuildRequires:	yagac-devel >= 0.99-4
Obsoletes:	clement-pgsql,clement-mysql,clement-systemd,clement-sysvinit
#---------------------------------------------------------------
buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


%description
Clement is an email firewall. Its purpose is to filter all email,
rejecting viruses and unwelcome messages at the SMTP protocol level
(and avoids bouncing to forged originators).
It also provide audit logs, allowing effective mean to search about email exchange 
within time and transaction context.

Clement extracts "email sending contexts" and can use a remote mentor
process to further analyze message context while still connected to the
remote sender process.

%files
%defattr(-,%{name},mail,-) 
%doc %{name}-%{version}*.build_date README
%{_var}/log/%{name}/
%{_usr}/lib/%{name}-%{version}/
%{_var}/lib/%{name}-%{version}/
%{_var}/www/%{name}-%{version}/
%{_sbindir}/%{name}
%{_bindir}/pibsmtp
%{_bindir}/clmsndr
%{_bindir}/clmailc
%{_bindir}/clmtrst
#system level.
%attr(-,root,root) %config(noreplace) %{_sysconfdir}/cron.d/%{name}
%config(noreplace) %{_sysconfdir}/pki/%{name}-%{version}/trusted.pem
%config(noreplace) %{_sysconfdir}/pki/%{name}-%{version}/startcom.ca.pem
%config(noreplace) %{_sysconfdir}/pki/%{name}-%{version}/StartComClass2PrimaryIntermediateServerCA
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
#rotating dovecot logs
%{_sysconfdir}/logrotate.d/clem-dovecot
#working level
%config(noreplace) %{_sysconfdir}/%{name}-%{version}/

%{_var}/spool/%{name}-%{version}/
%attr(0770,%{name},mail) %{_var}/crash/%{name}-%{version}/
%{_var}/lock/%{name}-%{version}/

%if "%sysinit" == "sysvinit"
%attr(0755,root,root) %{_initrddir}/%{name}
%endif

%if "%sysinit" == "systemd"
%{_unitdir}/clamd.clement.service
%{_unitdir}/clement.service
%config(noreplace) %{_sysconfdir}/clamd.d/clamd.%{name}.conf
%config(noreplace) %{_sysconfdir}/systemd/system/%{name}.service
%attr(0775,clement,mail) %dir %{_var}/run/clamd.clement
%ghost %attr(0644,clement,mail) %{_var}/log/clement/clamd.log
%endif
#-----------------------------------------------------------
#This is the RPM install/upgrade/remove directive
#-----------------------------------------------------------
#before install or upgrade
%pre
if [ "$1" = 1 ]; then
  /usr/sbin/useradd -g mail -M -d /var/spool/%{name}-%{version} \
        -c "${name} daemon" \
        -s /bin/bash %{name} 2>/dev/null || :
  fi
if [ "$1" = 2 ]; then
  if [ -d %{_sysconfdir}/%{name}-2.5 ] ; then
    /bin/sed	 						\
      -i							\
      -e "s/VERS=2.5/VERS=%{version}/"				\
	 %{_sysconfdir}/sysconfig/%{name}
    mv %{_sysconfdir}/%{name}-2.5 %{_sysconfdir}/%{name}-%{version}
    mv %{_sysconfdir}/pki/%{name}-2.5 %{_sysconfdir}/pki/%{name}-%{version}
    mv %{_var}/crash/%{name}-2.5 %{_var}/crash/%{name}-%{version}
    mv %{_var}/spool/%{name}-2.5 %{_var}/spool/%{name}-%{version}
    mv %{_var}/www/%{name}-2.5 %{_var}/www/%{name}-%{version}
    mv %{_var}/lock/%{name}-2.5 %{_var}/lock/%{name}-%{version}
    mv %{_var}/lib/%{name}-2.5 %{_var}/lib/%{name}-%{version}
    mv %{_usr}/lib/%{name}-2.5 %{_usr}/lib/%{name}-%{version}
    /bin/sed		 					\
      -i							\
      -e "s/clement-2.5/clement-%{version}/"			\
	 %{_sysconfdir}/%{name}-%{version}/%{name}.php
    fi
  if [ -f %{_usr}/lib/%{name}-%{version}/shell/version.sh ] ; then
    cp -f %{_usr}/lib/%{name}-%{version}/shell/version.sh	\
          %{_usr}/lib/%{name}-%{version}/shell/prev-version.sh
    fi
  fi


#after install or upgrade
%post
#fist install
%define AP_ARCH i386
%ifarch x86_64
%define AP_ARCH x86_64
%endif
if [ "$1" = 1 ]; then
  (
  echo "#------------------------------------------"
  echo "#Architecture type was set by rpm first install procedure"
  echo "#"`date`
  echo "AP_ARCH=%{?AP_ARCH}"
  echo "#------------------------------------------"
  ) >> %{_sysconfdir}/sysconfig/%{name}
  fi
#before re-install
if [ "$1" = 2 ]; then
  case "%{sysinit}" in
    "sysvinit"	)
	(
	if [ -f /var/lock/subsys/%{name} ] ; then
	  export GOCLEM="GO"
	  %{_initrddir}/%{name} stop 2>/dev/null || :
	  fi
	if [ -f /var/lock/subsys/dovecot ] ; then
	  export GODOV="GO"
	  %{_initrddir}/dovecot stop 2>/dev/null || :
	  fi
	sleep 5		#waiting clement full shutdown
	%{_usr}/lib/%{name}-%{version}/utilities/do_update.sh %{name}
	sleep 5		#waiting DB full shutdown
        if [ -n "$GODOV" ] ; then
	  %{_initrddir}/dovecot start 2>/dev/null || :
	  fi
	if [ -n "$GOCLEM" ] ; then
	  %{_initrddir}/%{name} start 2>/dev/null || :
	  fi
	)
       ;; 
    "systemd"	)
	(
	isactive=`systemctl is-active %{name}`
	if [ "$isactive" == "active" ] ; then
	export GOCLEM="GO"
	/bin/systemctl stop %{name} >/dev/null 2>&1
	fi
	isactive=`systemctl is-active dovecot`
	if [ "$isactive" == "active" ] ; then
	export GODOV="GO"
	/bin/systemctl stop dovecot >/dev/null 2>&1
	fi
	sleep 5		#waiting clement full shutdown
	%{_usr}/lib/%{name}-%{version}/utilities/do_update.sh %{name}
	sleep 5		#waiting DB full shutdown
	if [ -n "$GODOV" ] ; then
	/bin/systemctl start dovecot >/dev/null 2>&1
	fi
	if [ -n "$GOCLEM" ] ; then
	/bin/systemctl start %{name} >/dev/null 2>&1
	fi
	)
       ;; 
    "*"		)
	echo "Unexpect sysinit <"%{sysinit}">"
       ;;
    esac
  fi

#before upgrade or remove
%postun

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  /bin/echo "remaining file in this directory are data-base and logs"
  /bin/echo "created while %{name} was in production."
  /bin/echo "these files _may_ be removed too, but that they could"
  /bin/echo "contain valuable data and admin should be careful"
  /bin/echo "when removing them."
  ) > %{_var}/spool/%{name}-%{version}/README-%{name}-removed
  cp %{_var}/spool/%{name}-%{version}/README-%{name}-removed \
     %{_var}/lib/%{name}-%{version}/README-%{name}-removed
  /usr/sbin/userdel -r %{name} > /dev/null 2>&1 || true
  fi

#-----------------------------------------------------------
#common part
#-----------------------------------------------------------
%prep

%setup -q

%build
%{__rm} -rf %{buildroot}
%{?_smp_mflags:%define _smp_mflags -j `/usr/bin/getconf _NPROCESSORS_ONLN`}

#generating uptodate version information
/bin/sed 					\
  -e "s/=VERSION/=%{version}/"			\
  -e "s/=RELEASE/=4.8.1/"			\
	shell/version.tpl > shell/version.sh ;	\

%{__make} -s %{?_smp_mflags} prod

%clean 
%{__rm} -rf %{buildroot}

%install
#main install
%{__rm} -fr %{buildroot}
mkdir -p -m0755 %{buildroot}

%{__make} -s install APLV=%{name}-%{version}	\
	RELEASE=4.8.1			\
	DESTDIR=%{buildroot}

case "%{sysinit}" in 				\
  "sysvinit"	) 				\
     install -d %{buildroot}//etc/rc.d/init.d ;	\
     install -m0755 contrib/redhat/%{name}.init	\
	%{buildroot}//etc/rc.d/init.d/%{name} ;	\
     ;;						\
  "systemd"	) 				\
     install -d %{buildroot}/etc/clamd.d ;	\
     install -m0755				\
	contrib/fedora/clamd.%{name}.conf	\
	%{buildroot}/etc/clamd.d ;		\
     install -m0755 -d				\
	%{buildroot}%{_var}/run/clamd.%{name} ;	\
      install -d 				\
	%{buildroot}/etc/systemd/system;	\
      install -m0644 				\
	contrib/fedora/etc_%{name}.service	\
	%{buildroot}/etc/systemd/system/%{name}.service;\
      install -d %{buildroot}%{_unitdir} ;	\
      install -m0644 				\
	contrib/fedora/clamd.%{name}.service	\
	contrib/fedora/%{name}.service		\
	%{buildroot}%{_unitdir} ;		\
     ;;						\
  "*"	)					\
     /bin/echo "Unknown sysinit<"%{sysinit}">"; \
     ;;
  esac

%changelog
